; 
      .386
      .model flat, stdcall
      option casemap :none      ; case sensitive
; 
      include \masm32\include\windows.inc
      include \masm32\include\masm32.inc
      include \masm32\include\kernel32.inc
      include \masm32\include\odbc32.inc
      include \masm32\include\comctl32.inc
      include \masm32\include\user32.inc
      include \Masm32\include\gdi32.inc
      include \masm32\include\gdiplus.inc
      include \masm32\include\comdlg32.inc
      include \masm32\include\shell32.inc
      include \masm32\include\shlwapi.inc
      include \masm32\include\ole32.inc
      include \masm32\include\oleaut32.inc
      include \masm32\include\msvcrt.inc
      include \masm32\include\dialogs.inc
      include \masm32\macros\macros.asm
      include \masm32\include\Fpu.inc
      include \masm32\include\winspool.inc

      includelib \masm32\lib\masm32.lib
      includelib \masm32\lib\odbc32.lib
      includelib \masm32\lib\comctl32.lib
      includelib \masm32\lib\kernel32.lib
      includelib \masm32\lib\user32.lib
      includelib \Masm32\lib\gdi32.lib
      includelib \masm32\lib\gdiplus.lib
      includelib \masm32\lib\comdlg32.lib
      includelib \masm32\lib\shell32.lib
      includelib \masm32\lib\shlwapi.lib
      includelib \masm32\lib\ole32.lib
      includelib \masm32\lib\oleaut32.lib
      includelib \masm32\lib\msvcrt.lib
      includelib \masm32\lib\Fpu.lib
      includelib \masm32\lib\winspool.lib
; 
      IDD_MAINDLG     equ 101
      IDR_MAINMENU    equ 102
      IDC_DATALIST    equ 1000
      IDC_DATALIST2   equ 1010
      IDC_DATALIST3   equ 1011
      IDM_CONNECT     equ 40001
      IDM_DISCONNECT  equ 40002
      IDM_QUERY       equ 40003
      IDM_CUSTOMQUERY equ 40004
      IDM_TABLE       equ 40005
      IDM_COLUMN      equ 40006
      IDC_NAME        equ 1000
      IDC_OK          equ 1001
      IDC_CANCEL      equ 1002
      IDD_QUERYDLG    equ 102
      ID_STATIC       equ -1
; 
      DlgProc         proto hDlg :DWORD, uMsg :DWORD, wParam :DWORD, lParam :DWORD
      QueryProc       proto hDlg :DWORD, uMsg :DWORD, wParam :DWORD, lParam :DWORD
      GetProgramPath  proto
      SwitchMenuState proto :DWORD
      ODBCConnect     proto :DWORD
      ODBCDisconnect  proto :DWORD
      ; --------------------------------------- in MDBTable.asm
      InsertColumn    proto
      FillData        proto
      RunQuery        proto :DWORD
      ; --------------------------------------- in ODBCTable.asm
      InsertColumn2   proto
      RunTable        proto :DWORD
      FillData2       proto
      ; --------------------------------------- in ODBCCol.asm
      InsertColumn3   proto
      RunColumn       proto :DWORD
      FillData3       proto
; 
.data?
      hInstance       dd ?               ; instance handle
      hEnv            dd ?               ; environment handle
      hConn           dd ?               ; connection handle
      hStmt           dd ?               ; statement handle
      hStmt2          dd ?               ; statement handle
      hStmt3          dd ?               ; statement handle
      Conn            db 256 dup(?)      ; ODBC connect string
      StrLenCS        dd ?               ; length of ODBC connect string
      hMenu           dd ?               ; handle to the main menu
      hStatus         dd ?               ; handle to the static control
      hList           dd ?               ; handle to the listview control
      hList2          dd ?               ; handle to the listview control
      hList3          dd ?               ; handle to the listview control
      SearchName      db 26 dup(?)       ; Search buffer
      ProgPath        db 256 dup(?)      ; Local drive/path of application
      ConnectString   db 1024 dup(?)     ; ODBC connection string
      lf              LOGFONT <>
      hFontL          dd ?
      hFontS          dd ?
      Ps              PAINTSTRUCT <>
; 
.data
      SQLStatement    db "SELECT Sys_No, X01, X02, X03, X04, X05 FROM SSS", 0
      SQLStatement1   db "SELECT Sys_No, X01, X02, X03, X04, X05 FROM BBB", 0
      SQLTableStmt    db " ", 0
      WhereStatement  db " where Sys_No=?", 0
      strConnect      db "DRIVER={Microsoft Access Driver (*.mdb)};DBQ=", 0
      DBName          db "test.mdb", 0
      ConnectCaption  db "Complete Connection String", 0
      Disconnect      db "Disconnect successful", 0
      AppName         db "ODBC Test", 0
      AllocEnvFail    db "Environment handle allocation failed", 0
      AllocConnFail   db "Connection handle allocation failed", 0
      SetAttrFail     db "Cannot set desired ODBC version", 0
      NoData          db "You must type the name in the edit box", 0
      ExecuteFail     db "Execution of SQL statement failed", 0
      ConnFail        db "Connection attempt failed", 0
      AllocStmtFail   db "Statement handle allocation failed", 0
      sqlerr1         db "SQL Error", 13, 10, 0
      sqlerr2         db "Invalid Handle", 13, 10, 0
      sqlerr3         db "SQL needs more data", 13, 10, 0
      sqlerr4         db "SQL has no data", 13, 10, 0
      sqlerr5         db "SQL still executing", 13, 10, 0
      sqlstate        db 32 dup(0)
      Zrecords        db "No Records", 0
      DataBuffer      db 128 dup(0), 0  ; Temp for Listbox
      EmptyRecSet     db "Empty Recordset Returned", 0
      stevesql        dd 0
      FontMS          db "MS Sans Serif", 0
      FontYummy       db "Budmo Jiggler", 0
      FontYummy1      dd 0
      hDC             dd 0
      hFont2          dd 0
      szDisplayName   db "ODBC Testing", 0
; --------------------------------------------------------------------------------------------- ODBC Table interface
      RetTableCol1    db "Catalogs", 0
      RetTableCol2    db "Schemas", 0
      RetTableCol3    db "Tables", 0
      RetTableCol4    db "Types", 0
      RetTableCol5    db "Description", 0
      TStr01          db "SQL_ALL_TABLE_TYPES", 0
      TStr02          db "SQL_ALL_CATALOGS", 0
      TStr03          db "SQL_ALL_SCHEMAS", 0
      TStr04          db "TABLE", 0
      TStr05          db "SSS", 0
      TStr06          db "SYSTEM TABLE", 0
      TField01        db 256 dup(0)                ; field buffer used for Catalog Data
      TF1EOR          db 0                         ; Safety szMarker
      TField02        db 256 dup(0)                ; field buffer used for Schema Data
      TF2EOR          db 0                         ; Safety szMarker
      TField03        db 256 dup(0)                ; field buffer used for Table Name Data
      TF3EOR          db 0                         ; Safety szMarker
      TField04        db 256 dup(0)                ; field buffer used for Table Type Data
      TF4EOR          db 0                         ; Safety szMarker
      TField05        db 256 dup(0)                ; field buffer used for Table Description Data
      TF5EOR          db 0                         ; Safety szMarker
      TField01L       dd 0                         ; used for size of field buffer
      TField02L       dd 0                         ; used for size of field buffer
      TField03L       dd 0                         ; used for size of field buffer
      TField04L       dd 0                         ; used for size of field buffer
      TField05L       dd 0                         ; used for size of field buffer
; --------------------------------------------------------------------------------------------- ODBC Column interface
      RetColumnCol1   db "Catalogs", 0
      RetColumnCol2   db "Schemas", 0
      RetColumnCol3   db "Tables", 0
      RetColumnCol4   db "Column", 0
      RetColumnCol5   db "Data Type", 0
      RetColumnCol6   db "Type Name", 0
      RetColumnCol7   db "Col Size", 0
      RetColumnCol8   db "Buff Length", 0
      RetColumnCol9   db "Decimal Digits", 0
      RetColumnCol10  db "Num Radix", 0
      RetColumnCol11  db "Nullable", 0
      RetColumnCol12  db "Remarks", 0
      RetColumnCol13  db "Col Def", 0
      RetColumnCol14  db "SQL Data Type", 0
      RetColumnCol15  db "SQL Timestamp", 0
      RetColumnCol16  db "Char Length", 0
      RetColumnCol17  db "Ordinal", 0
      RetColumnCol18  db "Is Nullable", 0
      CStr01          db "SQL_ALL_TABLE_TYPES", 0
      CStr02          db "SQL_ALL_CATALOGS", 0
      CStr03          db "SQL_ALL_SCHEMAS", 0
      CStr04          db "TABLE", 0
      CStr05          db "SSS", 0
      CStr06          db "SYSTEM TABLE", 0
      CField01        db 256 dup(0)                ; field buffer used for Catalog Data
      CF1EOR          db 0                         ; Safety szMarker
      CField02        db 256 dup(0)                ; field buffer used for Schema Data
      CF2EOR          db 0                         ; Safety szMarker
      CField03        db 256 dup(0)                ; field buffer used for Table Name Data
      CF3EOR          db 0                         ; Safety szMarker
      CField04        db 256 dup(0)                ; field buffer used for Column Name Data
      CF4EOR          db 0                         ; Safety szMarker
      CField05        db 256 dup(0)                ; field buffer used for Data Type Data
      CF5EOR          db 0                         ; Safety szMarker
      CField06        db 256 dup(0)                ; field buffer used for Type Name Data
      CF6EOR          db 0                         ; Safety szMarker
      CField07        db 256 dup(0)                ; field buffer used for Col Size Data
      CF7EOR          db 0                         ; Safety szMarker
      CField08        db 256 dup(0)                ; field buffer used for Buff Length Data
      CF8EOR          db 0                         ; Safety szMarker
      CField09        db 256 dup(0)                ; field buffer used for Decimal Digits Data
      CF9EOR          db 0                         ; Safety szMarker
      CField10        db 256 dup(0)                ; field buffer used for Num Radix Data
      CF10EOR         db 0                         ; Safety szMarker
      CField11        db 256 dup(0)                ; field buffer used for Nullable Data
      CF11EOR         db 0                         ; Safety szMarker
      CField12        db 256 dup(0)                ; field buffer used for Remarks Data
      CF12EOR         db 0                         ; Safety szMarker
      CField13        db 256 dup(0)                ; field buffer used for Column Definition Data
      CF13EOR         db 0                         ; Safety szMarker
      CField14        db 256 dup(0)                ; field buffer used for SQL Data Type Data
      CF14EOR         db 0                         ; Safety szMarker
      CField15        db 256 dup(0)                ; field buffer used for SQL Timestamp Data
      CF15EOR         db 0                         ; Safety szMarker
      CField16        db 256 dup(0)                ; field buffer used for Char Length Data
      CF16EOR         db 0                         ; Safety szMarker
      CField17        db 256 dup(0)                ; field buffer used for Ordinal Data
      CF17EOR         db 0                         ; Safety szMarker
      CField18        db 256 dup(0)                ; field buffer used for Is Nullable Data
      CF18EOR         db 0                         ; Safety szMarker
      CField01L       dd 0                         ; used for size of field buffer
      CField02L       dd 0                         ; used for size of field buffer
      CField03L       dd 0                         ; used for size of field buffer
      CField04L       dd 0                         ; used for size of field buffer
      CField05L       dd 0                         ; used for size of field buffer
      CField06L       dd 0                         ; used for size of field buffer
      CField07L       dd 0                         ; used for size of field buffer
      CField08L       dd 0                         ; used for size of field buffer
      CField09L       dd 0                         ; used for size of field buffer
      CField10L       dd 0                         ; used for size of field buffer
      CField11L       dd 0                         ; used for size of field buffer
      CField12L       dd 0                         ; used for size of field buffer
      CField13L       dd 0                         ; used for size of field buffer
      CField14L       dd 0                         ; used for size of field buffer
      CField15L       dd 0                         ; used for size of field buffer
      CField16L       dd 0                         ; used for size of field buffer
      CField17L       dd 0                         ; used for size of field buffer
      CField18L       dd 0                         ; used for size of field buffer
; --------------------------------------------------------------------------------------------- ODBC Access Table SSS
      Heading0        db "Sys_No", 0
      Heading1        db "X01", 0
      Heading2        db "X02", 0
      Heading3        db "X03", 0
      Heading4        db "X04", 0
      Heading5        db "X05", 0
      ODBCField01     db 14 dup(0), 0              ; field buffer for Sys_No
      ODBCField02     db 14 dup(0), 0              ; field buffer for X01
      ODBCField03     db 14 dup(0), 0              ; field buffer for X02
      ODBCField04     db 14 dup(0), 0              ; field buffer for X03
      ODBCField05     db 14 dup(0), 0              ; field buffer for X04
      ODBCField06     db 14 dup(0), 0              ; field buffer for X05
      ODBCField01L    dd 14                        ; used for size of field buffer - Sys_No
      ODBCField02L    dd 14                        ; used for size of field buffer - X01
      ODBCField03L    dd 14                        ; used for size of field buffer - X02
      ODBCField04L    dd 14                        ; used for size of field buffer - X03
      ODBCField05L    dd 14                        ; used for size of field buffer - X04
      ODBCField06L    dd 14                        ; used for size of field buffer - X05
; 
.code
start:
    invoke GetModuleHandle, NULL
    mov hInstance, eax
    invoke InitCommonControls
    call GetProgramPath
    invoke DialogBoxParam, hInstance, IDD_MAINDLG, 0, addr DlgProc, 0
    invoke ExitProcess, eax
; 
      include MDBTable1.asm
      include ODBCTable.asm
      include ODBCCol.asm
; 
DlgProc proc hDlg :DWORD, uMsg :DWORD, wParam :DWORD, lParam :DWORD
    LOCAL Rct1 :RECT
    LOCAL nX1         :DWORD
    LOCAL nY1         :DWORD
    LOCAL nChar       :DWORD
    LOCAL saveFont    :DWORD
    LOCAL btn_hi :DWORD
    LOCAL btn_lo :DWORD
    LOCAL hbrush      :DWORD
    LOCAL hbrushold   :DWORD
    
    .if uMsg==WM_INITDIALOG
        invoke GetMenu, hDlg
        mov hMenu, eax
        invoke GetDlgItem, hDlg, IDC_DATALIST
        mov hList, eax
        call InsertColumn
        invoke GetDlgItem, hDlg, IDC_DATALIST2
        mov hList2, eax
        call InsertColumn2
        invoke GetDlgItem, hDlg, IDC_DATALIST3
        mov hList3, eax
        call InsertColumn3
        invoke GetDlgItem, hDlg, ID_STATIC
        mov hStatus, eax
        invoke lstrcpy, addr lf.lfFaceName, addr FontMS
        mov lf.lfHeight, -16
        mov lf.lfWeight, 600
        invoke CreateFontIndirect, addr lf
        mov hFontL, eax    ; Listview font
        invoke SendMessage, hList,  WM_SETFONT, hFontL, 1
        invoke SendMessage, hList2, WM_SETFONT, hFontL, 1
        invoke SendMessage, hList3, WM_SETFONT, hFontL, 1

        invoke lstrcpy, addr lf.lfFaceName, addr FontYummy
        mov lf.lfHeight, -72
        mov lf.lfWeight, 700
        invoke CreateFontIndirect, addr lf
        mov hFontS, eax    ; Static font
        invoke SendMessage, hStatus, WM_SETFONT, hFontS, 1

        mov eax, LVS_EX_FULLROWSELECT or LVS_EX_GRIDLINES
        invoke SendMessage, hList,  LVM_SETEXTENDEDLISTVIEWSTYLE, 0, eax
        mov eax, LVS_EX_FULLROWSELECT or LVS_EX_GRIDLINES
        invoke SendMessage, hList2, LVM_SETEXTENDEDLISTVIEWSTYLE, 0, eax
        mov eax, LVS_EX_FULLROWSELECT or LVS_EX_GRIDLINES
        invoke SendMessage, hList3, LVM_SETEXTENDEDLISTVIEWSTYLE, 0, eax
; ---------------------------------------------------------  BBGGRRh
        invoke SendMessage, hList,  LVM_SETTEXTCOLOR,   0, 008040FFh
        invoke SendMessage, hList,  LVM_SETBKCOLOR,     0, 00000000h
        invoke SendMessage, hList,  LVM_SETTEXTBKCOLOR, 0, 00000000h
        invoke SendMessage, hList2, LVM_SETTEXTCOLOR,   0, 004080FFh
        invoke SendMessage, hList2, LVM_SETBKCOLOR,     0, 00000000h
        invoke SendMessage, hList2, LVM_SETTEXTBKCOLOR, 0, 00000000h
        invoke SendMessage, hList3, LVM_SETTEXTCOLOR,   0, 0080FF00h
        invoke SendMessage, hList3, LVM_SETBKCOLOR,     0, 00000000h
        invoke SendMessage, hList3, LVM_SETTEXTBKCOLOR, 0, 00000000h
    .elseif uMsg==WM_CLOSE
        invoke GetMenuState, hMenu, IDM_CONNECT, MF_BYCOMMAND
        .if eax==MF_GRAYED
            invoke ODBCDisconnect, hDlg
        .endif
        invoke EndDialog, hDlg, 0
    .elseif uMsg==WM_COMMAND
        .if lParam==0
            mov eax,wParam
            .if ax==IDM_CONNECT
                invoke ShowWindow, hStatus, SW_HIDE
                invoke ODBCConnect, hDlg                
            .elseif ax==IDM_DISCONNECT
                invoke ODBCDisconnect, hDlg
                invoke ShowWindow, hStatus, SW_SHOW
            .elseif ax==IDM_QUERY
                invoke RunQuery, hDlg
            .elseif ax==IDM_CUSTOMQUERY
                invoke DialogBoxParam, hInstance, IDD_QUERYDLG, hDlg, addr QueryProc, 0
            .elseif ax==IDM_TABLE
                invoke RunTable, hDlg
            .elseif ax==IDM_COLUMN
                invoke RunColumn, hDlg
            .endif
        .endif
    .else
        mov eax, FALSE
        ret
    .endif
    mov eax, TRUE
    ret
DlgProc endp	
; 
GetProgramPath proc
    invoke GetModuleFileName, NULL, addr ProgPath,sizeof ProgPath
    std
    mov edi, offset ProgPath
    add edi, sizeof ProgPath - 1
    mov al, "\"
    mov ecx, sizeof ProgPath
    repne scasb
    cld
    mov byte ptr [edi + 2], 0
    ret
GetProgramPath endp
; 
SwitchMenuState proc Flag :DWORD
    .if Flag==TRUE 
        invoke EnableMenuItem, hMenu, IDM_CONNECT, MF_GRAYED
        invoke EnableMenuItem, hMenu, IDM_DISCONNECT, MF_ENABLED
        invoke EnableMenuItem, hMenu, IDM_QUERY, MF_ENABLED
        invoke EnableMenuItem, hMenu, IDM_CUSTOMQUERY, MF_ENABLED
        invoke EnableMenuItem, hMenu, IDM_TABLE, MF_ENABLED
        invoke EnableMenuItem, hMenu, IDM_COLUMN, MF_ENABLED
    .else
        invoke EnableMenuItem, hMenu, IDM_CONNECT, MF_ENABLED
        invoke EnableMenuItem, hMenu, IDM_DISCONNECT, MF_GRAYED
        invoke EnableMenuItem, hMenu, IDM_QUERY, MF_GRAYED
        invoke EnableMenuItem, hMenu, IDM_CUSTOMQUERY, MF_GRAYED
        invoke EnableMenuItem, hMenu, IDM_TABLE, MF_GRAYED
        invoke EnableMenuItem, hMenu, IDM_COLUMN, MF_GRAYED
    .endif
    ret
SwitchMenuState endp
; 
ODBCConnect proc hDlg :DWORD
    invoke SQLAllocHandle, SQL_HANDLE_ENV, SQL_NULL_HANDLE, addr hEnv
    .if ax==SQL_SUCCESS || ax==SQL_SUCCESS_WITH_INFO
        invoke SQLSetEnvAttr, hEnv, SQL_ATTR_ODBC_VERSION, SQL_OV_ODBC3, 0
        .if ax==SQL_SUCCESS || ax==SQL_SUCCESS_WITH_INFO
            invoke SQLAllocHandle, SQL_HANDLE_DBC, hEnv, addr hConn
            .if ax==SQL_SUCCESS || ax==SQL_SUCCESS_WITH_INFO
                invoke lstrcpy, addr ConnectString, addr strConnect        ; "DRIVER={Microsoft Access Driver (*.mdb)};DBQ="
                invoke lstrcat, addr ConnectString, addr ProgPath          ; inserts drive and path
                invoke lstrcat, addr ConnectString, addr DBName            ; "test.mdb"
                invoke SQLDriverConnect, hConn, hDlg, addr ConnectString, sizeof ConnectString, addr Conn, sizeof Conn, addr StrLenCS, SQL_DRIVER_COMPLETE
                .if ax==SQL_SUCCESS || ax==SQL_SUCCESS_WITH_INFO
                    invoke SwitchMenuState, TRUE
                    invoke MessageBox, hDlg, addr Conn, addr ConnectCaption, MB_OK + MB_ICONINFORMATION
                .else
                    invoke SQLFreeHandle, SQL_HANDLE_DBC, hConn
                    invoke SQLFreeHandle, SQL_HANDLE_ENV, hEnv
                    invoke MessageBox, hDlg, addr ConnFail, addr AppName, MB_OK + MB_ICONERROR
                .endif
            .else
                invoke SQLFreeHandle, SQL_HANDLE_ENV, hEnv
                invoke MessageBox, hDlg, addr AllocConnFail, addr AppName, MB_OK + MB_ICONERROR
            .endif
        .else
            invoke SQLFreeHandle, SQL_HANDLE_ENV, hEnv
            invoke MessageBox, hDlg, addr SetAttrFail, addr AppName, MB_OK + MB_ICONERROR
        .endif
    .else
        invoke MessageBox, hDlg, addr AllocEnvFail, addr AppName, MB_OK + MB_ICONERROR	
    .endif
    ret
ODBCConnect endp
; 
ODBCDisconnect proc hDlg :DWORD
    invoke SQLDisconnect, hConn
    invoke SQLFreeHandle, SQL_HANDLE_DBC, hConn
    invoke SQLFreeHandle, SQL_HANDLE_ENV, hEnv
    invoke SwitchMenuState, FALSE
    invoke ShowWindow, hList, SW_HIDE
    invoke ShowWindow, hList2, SW_HIDE
    invoke ShowWindow, hList3, SW_HIDE
    invoke MessageBox, hDlg, addr Disconnect, addr AppName, MB_OK + MB_ICONINFORMATION
    ret
ODBCDisconnect endp
; 
end start
Comments |

; -------------------------------- SQLState after SQLAllocHandle stmt
01000 General warning
08003 Connection does not exist
HY000 General error
HY001 Memory allocation error
HY009 Invalid use of null pointer
HY010 Function sequence error
HY013 Memory management error
HY014 Limit on the number of handles exceeded
HY092 Invalid attribute/option identifier
HYC00 Optional feature not implemented
HYT01 Connection timeout expired
IM001 Driver does not support this function
; -------------------------------- SQLState after SQLExecDirect stmt
01000 General warning
01001 Cursor operation conflict
01003 NULL value eliminated in set function
01004 String data, right truncated
01006 Privilege not revoked
01007 Privilege not granted
01S02 Option value changed
01S07 Fractional truncation
07002 COUNT field incorrect
07006 Restricted data type attribute violation
07S01 Invalid use of default parameter
08S01 Communication link failure
21S01 Insert value list does not match column list
21S02 Degree of derived table does not match column list
22001 String data, right truncation
22002 Indicator variable required but not supplied
22003 Numeric value out of range
22007 Invalid datetime format
22008 Datetime field overflow
22012 Division by zero
22015 Interval field overflow
22018 Invalid character value for cast specification
22019 Invalid escape character
22025 Invalid escape sequence
23000 Integrity constraint violation
24000 Invalid cursor state
34000 Invalid cursor name
3D000 Invalid catalog name
3F000 Invalid schema name
40001 Serialization failure
40003 Statement completion unknown
42000 Syntax error or access violation
42S01 Base table or view already exists
42S02 Base table or view not found
42S11 Index already exists
42S12 Index not found
42S21 Column already exists
42S22 Column not found
44000 WITH CHECK OPTION violation
HY000 General error
HY001 Memory allocation error
HY008 Operation canceled
HY009 Invalid use of null pointer
HY010 Function sequence error
HY013 Memory management error
HY090 Invalid string or buffer length
HY105 Invalid parameter type
HY109 Invalid cursor position
HYC00 Optional feature not implemented
HYT00 Timeout expired
HYT01 Connection timeout expired
IM001 Driver does not support this function
; ====================================================================================================================================
invoke SQLTables, StatementHandle, CatalogName, NameLength1, SchemaName, NameLength2, TableName, NameLength3, TableType, NameLength4
invoke SQLTables, hstmt1, NULL, 0, NULL, 0, NULL, 0, NULL, 0

all fields are inputs
    StatementHandle <SQLHSTMT>        ; Statement handle for retrieved results.
    CatalogName     <SQLCHAR *>       ; The CatalogName argument accepts search patterns if the SQL_ODBC_VERSION environment attribute is SQL_OV_ODBC3
                                      ; it does not accept search patterns if SQL_OV_ODBC2 is set. If a driver supports catalogs for some tables but not
                                      ; for others, such as when a driver retrieves data from different DBMSs, an empty string ("") denotes those tables
                                      ; that do not have catalogs. 
    NameLength1     <SQLSMALLINT> ax  ; Length in characters of *CatalogName.
    SchemaName      <SQLCHAR *>       ; String search pattern for schema names. If a driver supports schemas for some tables but not for others, such as
                                      ; when the driver retrieves data from different DBMSs, an empty string ("") denotes those tables that do not have schemas.
    NameLength2     <SQLSMALLINT> ax  ; Length in characters of *SchemaName.
    TableName       <SQLCHAR *>       ; String search pattern for table names.
    NameLength3     <SQLSMALLINT> ax  ; Length in characters of *TableName.
    TableType       <SQLCHAR *>       ; List of table types to match.
    NameLength4     <SQLSMALLINT> ax  ; Length in characters of *TableType.

    Returns   ax = {SQL_SUCCESS, SQL_SUCCESS_WITH_INFO, SQL_STILL_EXECUTING, SQL_ERROR, or SQL_INVALID_HANDLE}

    Summary   SQLTables returns the list of table, catalog, or schema names, and table types,
              stored in a specific data source. The driver returns the information as a result set.


SQLTables lists all tables in the requested range. A user may or may not have SELECT privileges to any of these tables. To check accessibility, an application can:

          Call SQLGetInfo and check the SQL_ACCESSIBLE_TABLES information type. 
          Call SQLTablePrivileges to check the privileges for each table.

Otherwise, the application must be able to handle a situation where the user selects a table for which SELECT privileges are not granted.

The SchemaName and TableName arguments accept search patterns.
          The CatalogName argument accepts search patterns if the SQL_ODBC_VERSION environment attribute is SQL_OV_ODBC3;
          it does not accept search patterns if SQL_OV_ODBC2 is set.

          If SQL_OV_ODBC3 is set, an ODBC 3.x driver will require that wildcard characters in the CatalogName argument
          be escaped to be treated literally. For more information about valid search patterns, see Pattern Value Arguments.

Note   For more information about the general use, arguments, and returned data of ODBC catalog functions, see Catalog Functions.
To support enumeration of catalogs, schemas, and table types, the following special semantics are defined
for the CatalogName, SchemaName, TableName, and TableType arguments of SQLTables: 

If CatalogName is SQL_ALL_CATALOGS and SchemaName and TableName are empty strings,
   the result set contains a list of valid catalogs for the data source. (All columns except the TABLE_CAT column contain NULLs.) 

If SchemaName is SQL_ALL_SCHEMAS and CatalogName and TableName are empty strings,
   the result set contains a list of valid schemas for the data source. (All columns except the TABLE_SCHEM column contain NULLs.) 

If TableType is SQL_ALL_TABLE_TYPES and CatalogName, SchemaName, and TableName are empty strings,
   the result set contains a list of valid table types for the data source. (All columns except the TABLE_TYPE column contain NULLs.) 

If TableType is not an empty string, it must contain a list of comma-separated values for the types of interest;
   each value may be enclosed in single quotation marks (') or unquoted, for example, 'TABLE', 'VIEW' or TABLE, VIEW.
   An application should always specify the table type in uppercase; the driver should convert the table type to whatever case
   is needed by the data source. If the data source does not support a specified table type, SQLTables does not return any results for that type.

SQLTables returns the results as a standard result set, ordered by TABLE_TYPE, TABLE_CAT, TABLE_SCHEM, and TABLE_NAME.
   For information about how this information might be used, see Uses of Catalog Data.

To determine the actual lengths of the TABLE_CAT, TABLE_SCHEM, and TABLE_NAME columns, an application can call SQLGetInfo
with the SQL_MAX_CATALOG_NAME_LEN, SQL_MAX_SCHEMA_NAME_LEN, and SQL_MAX_TABLE_NAME_LEN information types.


Catalog Functions
SQLTables           Returns a list of catalogs, schemas, tables, or table types in the data source. 
SQLColumns          Returns a list of columns in one or more tables. 
SQLStatistics       Returns a list of statistics about a single table. Also returns a list of indexes associated with that table. 
SQLSpecialColumns   Returns a list of columns that uniquely identifies a row in a single table. Also returns a list of columns in that table that are automatically updated. 
SQLPrimaryKeys      Returns a list of columns that compose the primary key of a single table.  
SQLForeignKeys      Returns a list of foreign keys in a single table or a list of foreign keys in other tables that refer to a single table. 
SQLTablePrivileges  Returns a list of privileges associated with one or more tables. 
SQLColumnPrivileges Returns a list of privileges associated with one or more columns in a single table. 
SQLProcedures       Returns a list of procedures in the data source. 
SQLProcedureColumns Returns a list of input and output parameters, the return value, and the columns in the result set of a single procedure. 
SQLGetTypeInfo      Returns a list of the SQL data types supported by the data source. These data types are generally used in CREATE TABLE and ALTER TABLE statements. 

Because SQLTables, SQLColumns, SQLStatistics, and SQLSpecialColumns conform to the X/Open CLI,
and SQLGetTypeInfo conforms to the ISO 92 CLI, they are implemented by most drivers.
The remaining catalog functions are in the ODBC conformance level.


Catalog function string arguments fall into four different types:
     ordinary argument (OA),
     pattern value argument (PV),
     identifier argument (ID),
     and value list argument (VL).

Most string arguments can be of one of two different types, depending on the value of the SQL_ATTR_METADATA_ID statement attribute.
The following table lists the arguments for each catalog function and describes the type of the argument for an SQL_TRUE or SQL_FALSE value of SQL_ATTR_METADATA_ID.


           invoke SQLSetStmtAttr, StatementHandle, Attribute, ValuePtr, StringLength with Attribute = SQL_ATTR_METADATA_ID
           Value Pointer to the value to be associated with Attribute.
           Depending on the value of Attribute, ValuePtr will be a 32-bit unsigned integer value or
           a pointer to a null-terminated character string, a binary buffer, or a driver-defined value.
           If the Attribute argument is a driver-specific value, ValuePtr may be a signed integer. 


Function                    Argument        Type when SQL_ATTR_METADATA_ID = SQL_FALSE          Type when SQL_ATTR_METADATA_ID = SQL_TRUE 
------------------------------------------------------------------------------------------------------------------------------------------
SQLColumnPrivileges         CatalogName                     OA                                              ID
                            SchemaName                      OA                                              ID
                            TableName                       OA                                              ID
                            ColumnName                      PV                                              ID
------------------------------------------------------------------------------------------------------------------------------------------
SQLColumns                  CatalogName                     OA                                              ID
                            SchemaName                      PV                                              ID
                            TableName                       PV                                              ID
                            ColumnName                      PV                                              ID
------------------------------------------------------------------------------------------------------------------------------------------
SQLForeignKeys              PKCatalogName                   OA                                              ID
                            PKSchemaName                    OA                                              ID
                            PKTableName                     OA                                              ID
                            FKCatalogName                   OA                                              ID
                            FKSchemaName                    OA                                              ID
                            FKTableName                     OA                                              ID
------------------------------------------------------------------------------------------------------------------------------------------
SQLPrimaryKeys              CatalogName                     OA                                              ID
                            SchemaName                      OA                                              ID
                            TableName                       OA                                              ID
------------------------------------------------------------------------------------------------------------------------------------------
SQLProcedureColumns         CatalogName                     OA                                              ID
                            SchemaName                      PV                                              ID
                            ProcName                        PV                                              ID
                            ColumnName                      PV                                              ID
------------------------------------------------------------------------------------------------------------------------------------------
SQLProcedures               CatalogName                     OA                                              ID
                            SchemaName                      PV                                              ID
                            ProcName                        PV                                              ID
------------------------------------------------------------------------------------------------------------------------------------------
SQLSpecialColumns           CatalogName                     OA                                              ID
                            SchemaName                      OA                                              ID
                            TableName                       OA                                              ID
------------------------------------------------------------------------------------------------------------------------------------------
SQLStatistics               CatalogName                     OA                                              ID
                            SchemaName                      OA                                              ID
                            TableName                       OA                                              ID
------------------------------------------------------------------------------------------------------------------------------------------
SQLTablePrivileges          CatalogName                     OA                                              ID
                            SchemaName                      PV                                              ID
                            TableName                       PV                                              ID
------------------------------------------------------------------------------------------------------------------------------------------
SQLTables                   CatalogName                     PV                                              ID
                            SchemaName                      PV                                              ID
                            TableName                       PV                                              ID
                            TableType                       VL                                              VL
------------------------------------------------------------------------------------------------------------------------------------------


Ordinary Arguments
When a catalog function string argument is an ordinary argument, it is treated as a literal string.
An ordinary argument accepts neither a string search pattern nor a list of values.
The case of an ordinary argument is significant, and quote characters in the string are taken literally.
These arguments are treated as ordinary arguments if the SQL_ATTR_METADATA_ID statement attribute is set to SQL_FALSE;
they are treated as identifier arguments instead if this attribute is set to SQL_TRUE.

If an ordinary argument is set to a null pointer and the argument is a required argument,
the function returns SQL_ERROR and SQLSTATE HY009 (Invalid use of null pointer).
If an ordinary argument is set to a null pointer and the argument is not a required argument,
the argument's behavior is driver-dependent. The required arguments are listed in the following table.


            Function                Required arguments
            SQLColumnPrivileges     TableName
            SQLForeignKeys          PKTableName, FKTableName
            SQLPrimaryKeys          TableName
            SQLSpecialColumns       TableName
            SQLStatistics           TableName
                            


Identifier Arguments
If a string in an identifier argument is quoted, the driver removes leading and trailing blanks and treats literally
the string within the quotation marks. If the string is not quoted, the driver removes trailing blanks and folds the
string to uppercase. Setting an identifier argument to a null pointer returns SQL_ERROR and SQLSTATE HY009 (Invalid use
of null pointer), unless the argument is a catalog name and catalogs are not supported.

These arguments are treated as identifier arguments if the SQL_ATTR_METADATA_ID statement attribute is set to SQL_TRUE.
In this case, the underscore (_) and the percent sign (%) will be treated as the actual character, not as a
search pattern character. These arguments are treated as either an ordinary argument or a pattern argument,
depending on the argument, if this attribute is set to SQL_FALSE.

Although identifiers containing special characters must be quoted in SQL statements, they must not be quoted
when passed as catalog function arguments, because quote characters passed to catalog functions are interpreted literally.
For example, suppose the identifier quote character (which is driver-specific and returned through SQLGetInfo)
is a double quotation mark ("). The first call to SQLTables returns a result set containing information about the
Accounts Payable table, while the second call returns information about the "Accounts Payable" table,
which is probably not what was intended.

SQLTables(hstmt1, NULL, 0, NULL, 0, "Accounts Payable", SQL_NTS, NULL, 0);
SQLTables(hstmt2, NULL, 0, NULL, 0, "\"Accounts Payable\"", SQL_NTS, NULL, 0);
Quoted identifiers are used to distinguish a true column name from a pseudo-column of the same name, such as ROWID in Oracle.
If "ROWID" is passed in an argument of a catalog function, the function will work with the ROWID pseudo-column if it exists.
If the pseudo-column does not exist, the function will work with the "ROWID" column.
If ROWID is passed in an argument of a catalog function, the function will work with the ROWID column.

Value List Arguments
A value list argument consists of a list of comma-separated values to be used for matching.
There is only one value list argument in the ODBC catalog functions: the TableType argument in SQLTables.
Setting TableType to a null pointer is the same as if it is set to SQL_ALL_TABLE_TYPES, which enumerates
all possible members of the value list. This argument is not affected by the SQL_ATTR_METADATA_ID statement attribute.
For more information, see the SQLTables function description.

|

