; 
InsertColumn3 proc
    LOCAL lvc :LV_COLUMN

; To determine the actual lengths of the TABLE_CAT, TABLE_SCHEM, and TABLE_NAME columns, an application can
; call SQLGetInfo with the SQL_MAX_CATALOG_NAME_LEN, SQL_MAX_SCHEMA_NAME_LEN, and SQL_MAX_TABLE_NAME_LEN information types.
; Note that pixels (column width) should equal the W char width times Qty returned by SQLGetInfo.
; Could make this automatic with a definitions file or profile.

             mov lvc.lx, 256                                       ; column width
             mov lvc.imask, LVCF_TEXT + LVCF_WIDTH                 ; LVCF_TEXT requires pszText, LVCF_WIDTH requires lx
             mov lvc.iSubItem, 0                                   ; zero-based index
             mov lvc.pszText, offset RetColumnCol1                 ; required because we used LVCF_TEXT above
             mov lvc.cchTextMax, SizeOf RetColumnCol1              ; pszText buffer size
	invoke SendMessage, hList3, LVM_INSERTCOLUMN, 1, addr lvc    ; adds column to viewlist - Catalog Name
;            mov lvc.imask, LVCF_TEXT + LVCF_WIDTH + LVCF_FMT      ; add formating capabillities to cols
;            mov lvc.fmt, LVCFMT_RIGHT                             ; the rest of the cols are assigned right justify
             mov lvc.lx, 128                                       ; new default column width
             mov lvc.iSubItem, 1                                   ; zero-based index
             mov lvc.pszText, offset RetColumnCol2                 ; required because we used LVCF_TEXT above
             mov lvc.cchTextMax,  SizeOf RetColumnCol2             ; pszText buffer size
	invoke SendMessage, hList3, LVM_INSERTCOLUMN, 2, addr lvc    ; adds column to viewlist - Schema Data
             mov lvc.iSubItem, 2                                   ; zero-based index
             mov lvc.pszText, offset RetColumnCol3                 ; required because we used LVCF_TEXT above
             mov lvc.cchTextMax,  SizeOf RetColumnCol3             ; pszText buffer size
	invoke SendMessage, hList3, LVM_INSERTCOLUMN, 3, addr lvc    ; adds column to viewlist - Table Name Data
             mov lvc.iSubItem, 3                                   ; zero-based index
             mov lvc.pszText, offset RetColumnCol4                 ; required because we used LVCF_TEXT above
             mov lvc.cchTextMax,  SizeOf RetColumnCol4             ; pszText buffer size
	invoke SendMessage, hList3, LVM_INSERTCOLUMN, 4, addr lvc    ; adds column to viewlist - Table Type Data
             mov lvc.iSubItem, 4                                   ; zero-based index
             mov lvc.pszText, offset RetColumnCol5                 ; required because we used LVCF_TEXT above
             mov lvc.cchTextMax,  SizeOf RetColumnCol5             ; pszText buffer size
	invoke SendMessage, hList3, LVM_INSERTCOLUMN, 5, addr lvc    ; adds column to viewlist - Table Description Data
             mov lvc.iSubItem, 5                                   ; zero-based index
             mov lvc.pszText, offset RetColumnCol6                 ; required because we used LVCF_TEXT above
             mov lvc.cchTextMax,  SizeOf RetColumnCol6             ; pszText buffer size
	invoke SendMessage, hList3, LVM_INSERTCOLUMN, 6, addr lvc    ; adds column to viewlist - Table Description Data
             mov lvc.iSubItem, 6                                   ; zero-based index
             mov lvc.pszText, offset RetColumnCol7                 ; required because we used LVCF_TEXT above
             mov lvc.cchTextMax,  SizeOf RetColumnCol7             ; pszText buffer size
	invoke SendMessage, hList3, LVM_INSERTCOLUMN, 7, addr lvc    ; adds column to viewlist - Table Description Data
             mov lvc.iSubItem, 7                                   ; zero-based index
             mov lvc.pszText, offset RetColumnCol8                 ; required because we used LVCF_TEXT above
             mov lvc.cchTextMax,  SizeOf RetColumnCol8             ; pszText buffer size
	invoke SendMessage, hList3, LVM_INSERTCOLUMN, 8, addr lvc    ; adds column to viewlist - Table Description Data
             mov lvc.iSubItem, 8                                   ; zero-based index
             mov lvc.pszText, offset RetColumnCol9                 ; required because we used LVCF_TEXT above
             mov lvc.cchTextMax,  SizeOf RetColumnCol9             ; pszText buffer size
	invoke SendMessage, hList3, LVM_INSERTCOLUMN, 9, addr lvc    ; adds column to viewlist - Table Description Data
             mov lvc.iSubItem, 9                                   ; zero-based index
             mov lvc.pszText, offset RetColumnCol10                ; required because we used LVCF_TEXT above
             mov lvc.cchTextMax,  SizeOf RetColumnCol10            ; pszText buffer size
	invoke SendMessage, hList3, LVM_INSERTCOLUMN, 10, addr lvc   ; adds column to viewlist - Table Description Data
             mov lvc.iSubItem, 10                                  ; zero-based index
             mov lvc.pszText, offset RetColumnCol11                ; required because we used LVCF_TEXT above
             mov lvc.cchTextMax,  SizeOf RetColumnCol11            ; pszText buffer size
	invoke SendMessage, hList3, LVM_INSERTCOLUMN, 11, addr lvc   ; adds column to viewlist - Table Description Data
             mov lvc.iSubItem, 11                                  ; zero-based index
             mov lvc.pszText, offset RetColumnCol12                ; required because we used LVCF_TEXT above
             mov lvc.cchTextMax,  SizeOf RetColumnCol12            ; pszText buffer size
	invoke SendMessage, hList3, LVM_INSERTCOLUMN, 12, addr lvc   ; adds column to viewlist - Table Description Data
             mov lvc.iSubItem, 12                                  ; zero-based index
             mov lvc.pszText, offset RetColumnCol13                ; required because we used LVCF_TEXT above
             mov lvc.cchTextMax,  SizeOf RetColumnCol13            ; pszText buffer size
	invoke SendMessage, hList3, LVM_INSERTCOLUMN, 13, addr lvc   ; adds column to viewlist - Table Description Data
             mov lvc.iSubItem, 13                                  ; zero-based index
             mov lvc.pszText, offset RetColumnCol14                ; required because we used LVCF_TEXT above
             mov lvc.cchTextMax,  SizeOf RetColumnCol14            ; pszText buffer size
	invoke SendMessage, hList3, LVM_INSERTCOLUMN, 14, addr lvc   ; adds column to viewlist - Table Description Data
             mov lvc.iSubItem, 14                                  ; zero-based index
             mov lvc.pszText, offset RetColumnCol15                ; required because we used LVCF_TEXT above
             mov lvc.cchTextMax,  SizeOf RetColumnCol15            ; pszText buffer size
	invoke SendMessage, hList3, LVM_INSERTCOLUMN, 15, addr lvc   ; adds column to viewlist - Table Description Data
             mov lvc.iSubItem, 15                                  ; zero-based index
             mov lvc.pszText, offset RetColumnCol16                ; required because we used LVCF_TEXT above
             mov lvc.cchTextMax,  SizeOf RetColumnCol16            ; pszText buffer size
	invoke SendMessage, hList3, LVM_INSERTCOLUMN, 16, addr lvc   ; adds column to viewlist - Table Description Data
             mov lvc.iSubItem, 16                                  ; zero-based index
             mov lvc.pszText, offset RetColumnCol17                ; required because we used LVCF_TEXT above
             mov lvc.cchTextMax,  SizeOf RetColumnCol17            ; pszText buffer size
	invoke SendMessage, hList3, LVM_INSERTCOLUMN, 17, addr lvc   ; adds column to viewlist - Table Description Data
             mov lvc.iSubItem, 17                                  ; zero-based index
             mov lvc.pszText, offset RetColumnCol18                ; required because we used LVCF_TEXT above
             mov lvc.cchTextMax,  SizeOf RetColumnCol18            ; pszText buffer size
	invoke SendMessage, hList3, LVM_INSERTCOLUMN, 18, addr lvc   ; adds column to viewlist - Table Description Data
    ret
InsertColumn3 endp
; 
FillData3 proc
    LOCAL lvi :LV_ITEM
    LOCAL row :DWORD
    LOCAL pNumCols :WORD

    invoke SQLBindCol, hStmt3,  1, SQL_C_CHAR, addr CField01, sizeof CField01, addr CField01L
    invoke SQLBindCol, hStmt3,  2, SQL_C_CHAR, addr CField02, sizeof CField02, addr CField02L
    invoke SQLBindCol, hStmt3,  3, SQL_C_CHAR, addr CField03, sizeof CField03, addr CField03L
    invoke SQLBindCol, hStmt3,  4, SQL_C_CHAR, addr CField04, sizeof CField04, addr CField04L
    invoke SQLBindCol, hStmt3,  5, SQL_C_CHAR, addr CField05, sizeof CField05, addr CField05L
    invoke SQLBindCol, hStmt3,  6, SQL_C_CHAR, addr CField06, sizeof CField06, addr CField06L
    invoke SQLBindCol, hStmt3,  7, SQL_C_CHAR, addr CField07, sizeof CField07, addr CField07L
    invoke SQLBindCol, hStmt3,  8, SQL_C_CHAR, addr CField08, sizeof CField08, addr CField08L
    invoke SQLBindCol, hStmt3,  9, SQL_C_CHAR, addr CField09, sizeof CField09, addr CField09L
    invoke SQLBindCol, hStmt3, 10, SQL_C_CHAR, addr CField10, sizeof CField10, addr CField10L
    invoke SQLBindCol, hStmt3, 11, SQL_C_CHAR, addr CField11, sizeof CField11, addr CField11L
    invoke SQLBindCol, hStmt3, 12, SQL_C_CHAR, addr CField12, sizeof CField12, addr CField12L
    invoke SQLBindCol, hStmt3, 13, SQL_C_CHAR, addr CField13, sizeof CField13, addr CField13L
    invoke SQLBindCol, hStmt3, 14, SQL_C_CHAR, addr CField14, sizeof CField14, addr CField14L
    invoke SQLBindCol, hStmt3, 15, SQL_C_CHAR, addr CField15, sizeof CField15, addr CField15L
    invoke SQLBindCol, hStmt3, 16, SQL_C_CHAR, addr CField16, sizeof CField16, addr CField16L
    invoke SQLBindCol, hStmt3, 17, SQL_C_CHAR, addr CField17, sizeof CField17, addr CField17L
    invoke SQLBindCol, hStmt3, 18, SQL_C_CHAR, addr CField18, sizeof CField18, addr CField18L
    invoke SendMessage, hList3, WM_SETREDRAW, 0, 0   ; stop the updating of the screen area while loading hList
    mov row, 0
    .while TRUE
           mov byte ptr ds:[CField01], 0 ; We initalize the buffers to zero, incase there is no data selected
           mov byte ptr ds:[CField02], 0 ;    and we still want our procedure to finish without erroring out
           mov byte ptr ds:[CField03], 0
           mov byte ptr ds:[CField04], 0
           mov byte ptr ds:[CField05], 0
           mov byte ptr ds:[CField06], 0
           mov byte ptr ds:[CField07], 0
           mov byte ptr ds:[CField08], 0
           mov byte ptr ds:[CField09], 0
           mov byte ptr ds:[CField10], 0
           mov byte ptr ds:[CField11], 0
           mov byte ptr ds:[CField12], 0
           mov byte ptr ds:[CField13], 0
           mov byte ptr ds:[CField14], 0
           mov byte ptr ds:[CField15], 0
           mov byte ptr ds:[CField16], 0
           mov byte ptr ds:[CField17], 0
           mov byte ptr ds:[CField18], 0
           invoke SQLFetch, hStmt3
           .if ax == SQL_SUCCESS
                mov lvi.imask, LVIF_TEXT + LVIF_PARAM
                push row
                pop lvi.iItem
                mov lvi.iSubItem, 0
                mov lvi.pszText, offset CField01
                push row
                pop lvi.lParam
                invoke SendMessage, hList3, LVM_INSERTITEM, 0, addr lvi
                    mov lvi.imask, LVIF_TEXT
                    inc lvi.iSubItem
                    mov lvi.pszText, offset CField02
                invoke SendMessage, hList3, LVM_SETITEM, 0, addr lvi
                    inc lvi.iSubItem
                    mov lvi.pszText, offset CField03
                invoke SendMessage, hList3, LVM_SETITEM, 0, addr lvi
                    inc lvi.iSubItem
                    mov lvi.pszText, offset CField04
                invoke SendMessage, hList3, LVM_SETITEM, 0, addr lvi
                    inc lvi.iSubItem
                    mov lvi.pszText, offset CField05
                invoke SendMessage, hList3, LVM_SETITEM, 0, addr lvi
                    inc lvi.iSubItem
                    mov lvi.pszText, offset CField06
                invoke SendMessage, hList3, LVM_SETITEM, 0, addr lvi
                    inc lvi.iSubItem
                    mov lvi.pszText, offset CField07
                invoke SendMessage, hList3, LVM_SETITEM, 0, addr lvi
                    inc lvi.iSubItem
                    mov lvi.pszText, offset CField08
                invoke SendMessage, hList3, LVM_SETITEM, 0, addr lvi
                    inc lvi.iSubItem
                    mov lvi.pszText, offset CField09
                invoke SendMessage, hList3, LVM_SETITEM, 0, addr lvi
                    inc lvi.iSubItem
                    mov lvi.pszText, offset CField10
                invoke SendMessage, hList3, LVM_SETITEM, 0, addr lvi
                    inc lvi.iSubItem
                    mov lvi.pszText, offset CField11
                invoke SendMessage, hList3, LVM_SETITEM, 0, addr lvi
                    inc lvi.iSubItem
                    mov lvi.pszText, offset CField12
                invoke SendMessage, hList3, LVM_SETITEM, 0, addr lvi
                    inc lvi.iSubItem
                    mov lvi.pszText, offset CField13
                invoke SendMessage, hList3, LVM_SETITEM, 0, addr lvi
                    inc lvi.iSubItem
                    mov lvi.pszText, offset CField14
                invoke SendMessage, hList3, LVM_SETITEM, 0, addr lvi
                    inc lvi.iSubItem
                    mov lvi.pszText, offset CField15
                invoke SendMessage, hList3, LVM_SETITEM, 0, addr lvi
                    inc lvi.iSubItem
                    mov lvi.pszText, offset CField16
                invoke SendMessage, hList3, LVM_SETITEM, 0, addr lvi
                    inc lvi.iSubItem
                    mov lvi.pszText, offset CField17
                invoke SendMessage, hList3, LVM_SETITEM, 0, addr lvi
                    inc lvi.iSubItem
                    mov lvi.pszText, offset CField18
                invoke SendMessage, hList3, LVM_SETITEM, 0, addr lvi
                inc row
            .else
                .if row == 0
                    mov lvi.imask, LVIF_TEXT + LVIF_PARAM
                    push row
                    pop lvi.iItem
                    mov lvi.iSubItem, 0
                    mov lvi.pszText, offset Zrecords
                    push row
                    pop lvi.lParam
                    invoke SendMessage, hList3, LVM_INSERTITEM, 0, addr lvi
                .endif
                .break   ; when no more records left, we exit the infinite loop
            .endif
    .endw
    invoke SendMessage, hList3, WM_SETREDRAW, 1, 0       ; start the updating of the screen area for hList
    invoke ShowWindow, hList3, SW_SHOW
    ret
FillData3 endp
; 
RunColumn proc hDlg :DWORD
    invoke ShowWindow, hList, SW_HIDE
    invoke ShowWindow, hList2, SW_HIDE
    invoke ShowWindow, hList3, SW_HIDE
    invoke SendMessage, hList3, LVM_DELETEALLITEMS, 0, 0
    invoke SQLAllocHandle, SQL_HANDLE_STMT, hConn, addr hStmt3
    .if ax==SQL_SUCCESS || ax==SQL_SUCCESS_WITH_INFO
        ; --------------------------------------------------------- We initalize the buffers to zero, incase there is no data selected
        ;                                                           and we still want to process to finish without erroring out
        mov byte ptr ds:[CField01], 0
        mov byte ptr ds:[CField02], 0
        mov byte ptr ds:[CField03], 0
        mov byte ptr ds:[CField04], 0
        ; --------------------------------------------------------- Ok now apply search patterns to Table strings
        invoke lstrcpy, addr CField04, addr TStr06                     ; TStr04 or TStr06
        ; --------------------------------------------------------- Ok now determine string lengths - run time method
        invoke szLen, ADDR CField01
        mov CField01L, eax
        invoke szLen, ADDR CField02
        mov CField02L, eax
        invoke szLen, ADDR CField03
        mov CField03L, eax
        invoke szLen, ADDR CField04
        mov CField04L, eax
        ; --------------------------------------------------------- After applying seaarch pattern - execute function
        invoke SQLColumns, hStmt3, NULL, 0, NULL, 0, NULL, 0, NULL, 0      ; Gets everything in the Columns Collection
        .if ax==SQL_SUCCESS || ax==SQL_SUCCESS_WITH_INFO
            invoke FillData3
        .elseif ax == SQL_ERROR
            invoke ShowWindow, hList3, SW_HIDE
            invoke MessageBox, hDlg, addr sqlerr1, addr AppName, MB_OK     ; SQL Error
        .elseif ax == SQL_INVALID_HANDLE
            invoke ShowWindow, hList3, SW_HIDE
            invoke MessageBox, hDlg, addr sqlerr2, addr AppName, MB_OK     ; Invalid Handle
        .elseif ax == SQL_NEED_DATA
            invoke ShowWindow, hList3, SW_HIDE
            invoke MessageBox, hDlg, addr sqlerr3, addr AppName, MB_OK     ; SQL incomplete
        .elseif ax == SQL_NO_DATA
            invoke ShowWindow, hList3, SW_HIDE
            invoke MessageBox, hDlg, addr sqlerr4, addr AppName, MB_OK     ; SQL returned no data
        .elseif ax == SQL_STILL_EXECUTING
            invoke MessageBox, hDlg, addr sqlerr5, addr AppName, MB_OK     ; Still executing SQL stmt
        .else
            invoke ShowWindow, hList3, SW_HIDE
            invoke MessageBox, hDlg, addr ExecuteFail, addr AppName, MB_OK + MB_ICONERROR
        .endif
        invoke SQLCloseCursor, hStmt3
        invoke SQLFreeHandle, SQL_HANDLE_STMT, hStmt2
    .else
        invoke ShowWindow, hList3, SW_HIDE
        invoke MessageBox, hDlg, addr AllocStmtFail, addr AppName, MB_OK + MB_ICONERROR
    .endif
    ret
RunColumn endp
; 
